Results 1 to 5 of 5

Thread: Selecionar e mover um bloco?

  1. #1
    Member
    Join Date
    2009-05
    Posts
    5
    Login to Give a bone
    0

    Question Selecionar e mover um bloco?

    Olá!
    Galera, estou iniciando meus estudos no ObjectARX .net, gostaria de uma ajuda, um exemplo, uma dica, pode ser em c# ou vb, preciso selecionar um bloco de forma automática, o seja sem clicar sobre o bloco e mover ele para uma nova posição.
    Valeu galera, qualquer ajuda é bem vinda!

  2. #2
    Member
    Join Date
    2008-10
    Location
    São Paulo
    Posts
    7
    Login to Give a bone
    0

    Default Re: Selecionar e mover um bloco?

    Eugenio,

    Se vc quer selecionar um bloco sem clicar no bloco, é necessário ter algum critério de seleção. Por exemplo: vc quer mover todos os blocos? somente as referencias de bloco de um determinado bloco? etc.

    Após selecionado e aberto, a referencia pode ser movida através da propriedade que define a posição.

    Boa sorte,

  3. #3
    Member
    Join Date
    2009-05
    Posts
    5
    Login to Give a bone
    0

    Cool Re: Selecionar e mover um bloco?

    Olá Augusto!
    Na verdade possuo um desenho de um braço mecânico, este braço é formado por blocos, quero dar movimeto a este braço mecânico, vou mover cada bloco por vez, por este motivo preciso selecionar o bloco sem clicar sobre ele para seleciona-lo e logo em seguida mover sua posição. Tenho todas as informações deste bloco, nome, posição inicial... qualquer dica é muito bem vinda!!!

  4. #4
    Member
    Join Date
    2008-10
    Location
    São Paulo
    Posts
    7
    Login to Give a bone
    0

    Default Re: Selecionar e mover um bloco?

    Eugenio,

    Entendi....acredito que vc pode selecionar os blocos pelo nome a partir da BlockTable. Então mudar a propriedade Position.

    Acredito que vc me enviou um email algum tempo atrás (06/05/09). Esta mensagem chegou corretamente?

  5. #5
    Member
    Join Date
    2009-05
    Posts
    5
    Login to Give a bone
    0

    Default Re: Selecionar e mover um bloco?

    [CommandMethod("mover")]
    public void mover()
    {
    Database acadDB = HostApplicationServices.WorkingDatabase;
    Autodesk.AutoCAD.DatabaseServices.TransactionManager
    acadTransmgr = acadDB.TransactionManager;
    Transaction acadTrans = acadTransmgr.StartTransaction();
    Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
    try
    {
    PromptSelectionOptions selOpts = new PromptSelectionOptions();
    PromptSelectionResult res = ed.SelectAll(new SelectionFilter
    (new TypedValue[] { new TypedValue(0, "INSERT"),
    new TypedValue(2, "A$C36615BC7")})); //Nome do bloco

    Autodesk.AutoCAD.EditorInput.SelectionSet SS = res.Value;

    Point3d fromPt;
    Point3d toPt;
    fromPt = new Point3d(0, 0, 0);

    //ptTo = ed.GetPoint("Pick a to point");
    toPt = new Point3d(1, 0, 0);
    //toPt = ptTo.Value;
    Vector3d moveVec = new Vector3d(toPt.X - fromPt.X, toPt.Y - fromPt.Y, toPt.Z - fromPt.Z);
    ObjectId[] idarray = SS.GetObjectIds();
    foreach (ObjectId id in idarray)
    {

    Entity ent = (Entity)acadTrans.GetObject(id, OpenMode.ForWrite, true);
    Matrix3d moveMat = Matrix3d.Displacement(moveVec);

    ent.TransformBy(ent.Ecs.PostMultiplyBy(moveMat));

    }
    acadTrans.Commit();
    }
    catch (System.Exception ex)
    {
    ed.WriteMessage(ex.ToString());
    acadTrans.Abort();
    }
    finally
    {
    acadTrans.Dispose();
    }

    }
    Bom galera, eu fiz desta forma, não sei se está correto mais deu certor!

Similar Threads

  1. Mover
    By tuomo.jarvinen in forum AutoLISP
    Replies: 4
    Last Post: 2014-01-21, 01:17 PM
  2. PROBLEMAS AL MOVER COSAS EN DIBUJOS GRANDES.
    By cfleiss774351 in forum Español - CHAT
    Replies: 0
    Last Post: 2011-10-17, 10:25 AM
  3. ayuda error al selecionar subassembly tool palettes
    By ociosidad in forum Español - AutoCAD Civil 3D
    Replies: 1
    Last Post: 2009-06-08, 10:05 PM
  4. Selecionar objeto fora da area de visualizaçao
    By rigolino in forum Português - AutoCAD / AutoCAD LT
    Replies: 2
    Last Post: 2009-05-15, 03:50 PM
  5. Selecionar e Obter informações do objeto atraves do VBA
    By marcio.cartacho in forum Português - Customização / Programação
    Replies: 3
    Last Post: 2008-05-20, 01:55 PM

Posting Permissions

  • You may not post new threads
  • You may not post replies
  • You may not post attachments
  • You may not edit your posts
  •